
#include <os.h>

#include "pieces.h"
#include "screen.h"

//http://hackspire.unsads.com/wiki/index.php/Memory-mapped_I/O_ports#900D0000_-_Second_timer
//http://infocenter.arm.com/help/index.jsp?topic=/com.arm.doc.ddi0271d/Babdajbi.html

//19Sep12  - update for CX (gray-scale) by SpiroH
//		   - org version work fines in B&W in ClickPad
//	     
int main(void)
{

	//SpiroH 
	volatile unsigned *divider 	= (unsigned*) 		(has_colors? 0x900D0000:0x900D0010);
    unsigned char *slowtc 	   	= (unsigned char *)	(has_colors? 0x900D0018:0x900D0014);	
    unsigned char *fasttc      	= (unsigned char *) (has_colors? 0x90010018:0x90010014);  
		
	
    unsigned orig_divider   =*divider;
    unsigned orig_fasttc	=*fasttc;
    unsigned orig_slowtc    =*slowtc;
	
	//keyboard poll interval
	unsigned cx_fact = has_colors?16:1;
    *fasttc  = 15;
	if(is_classic)*slowtc  = 0; //SpiroH
	*divider = 32*cx_fact-1;
	
	if(has_colors)lcd_ingray(); //SpiroH 
	
    clrscr();
	init();

	while(!isKeyPressed(KEY_NSPIRE_ESC))
    {
		
        if(isKeyPressed(KEY_NSPIRE_LEFT)||isKeyPressed(KEY_NSPIRE_4))
        {
			move(TT_MOVE_LEFT);
        }
        if(isKeyPressed(KEY_NSPIRE_RIGHT)||isKeyPressed(KEY_NSPIRE_6))
        {
			move(TT_MOVE_RIGHT);
        }
        if(isKeyPressed(KEY_NSPIRE_DOWN)||isKeyPressed(KEY_NSPIRE_2))
        {
			move(TT_MOVE_DOWN);
        }
        if(isKeyPressed(KEY_NSPIRE_UP)||isKeyPressed(KEY_NSPIRE_8))
        {
			move(TT_MOVE_UP);
        }
        if(isKeyPressed(KEY_NSPIRE_CLICK)||isKeyPressed(KEY_NSPIRE_5))
        {
			move(TT_MOVE_CLICK);
        }
		
        autom();
        idle();
    }
		
	
    *divider = orig_divider; 
	*fasttc  = orig_fasttc;	 
	if(is_classic)*slowtc  = orig_slowtc; //SpiroH	
	restore_timer(); //SpiroH
		
    return 0;
}
