#include <os.h>
#include "screen.h"
#include "pieces.h"

int kpiece,rpiece,nkpiece,nrpiece,level,lines,bonus,posx[5],posy[5];
unsigned long score,seed;

unsigned timer_value_to_restore=0; //SpiroH

inline unsigned* get_timer(){ return (unsigned*)(has_colors? 0x900D0004:0x900D000C);} //SpiroH

inline void restore_timer()
{
	*get_timer()=timer_value_to_restore;
}
//-----------------
inline void setPixel(int x, int y, int color) //ExtendeD
{
    if( x>=0 && x < SCREEN_WIDTH && y>=0 && y< SCREEN_HEIGHT && color>=0 && color <=15 )
    {
        unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
        *p = (x & 1) ? ((*p & 0xF0) | color) : ((*p & 0x0F) | (color << 4));
    }
	
}
//-----------------
inline int getPixel(int x, int y) //ExtendeD
{
    if( x>=0 && x < SCREEN_WIDTH && y >=0 && y < SCREEN_HEIGHT)
    {
        unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
        return ((x & 1) ? (*p & 0x0F) : (*p >> 4));
    }
    return 0;
}
//-----------------
void obj(int xpos,int ypos)
{
    int i,j;
    for(i=0; i<12; i++)
    {
        for(j=0; j<12; j++)
        {
            setPixel(xpos+j,ypos+i,gettexture(kpiece,j,i));
        }
    }
}

//-----------------
void delobj(int xpos,int ypos)
{
    int i,j;
    for(i=0; i<12; i++)
    {
        for(j=0; j<12; j++)
        {
            setPixel(xpos+j,ypos+i,15);
        }
    }
}

//-----------------
void piece(int del)
{
    int i,j;
    for(i=0; i<5; i++)
    {
        for(j=0; j<5; j++)
        {
            if(getpiece(kpiece,rpiece,j,i)==1)
            {
                switch(del)
                {
                case 0:
                    obj(posx[j],posy[i]);
                    break;
                case 1:
                    delobj(posx[j],posy[i]);
                    break;
                }

            }
        }
    }
}

//-----------------
void init()
{
    int i,j,l,k;
	
	unsigned int *counter = (unsigned int *)(has_colors?  0x90010004:0x9001000C); //SpiroH
	
    for(i=0; i< SCREEN_HEIGHT; i++)
    {
        for(j=0; j<100; j++) setPixel(j,i,3);
        for(j=220; j<SCREEN_WIDTH; j++) setPixel(j,i,3);
    }
	
    for(i=40; i<79; i++)
    {
        for(j=0; j<100; j++) setPixel(j,i,6);
        for(j=220; j < SCREEN_WIDTH; j++) setPixel(j,i,6);
    }
	
    for(i=120; i<160; i++)
    {
        for(j=0; j<100; j++) setPixel(j,i,5);		
        for(j=220; j< SCREEN_WIDTH; j++) setPixel(j,i,5);
    }
	
    for(i=205; i<SCREEN_HEIGHT; i++)
    {
        for(j=0; j<100; j++) setPixel(j,i,4);
        for(j=220; j<SCREEN_WIDTH; j++) setPixel(j,i,4);
    }
    for(i=0; i<SCREEN_HEIGHT; i++)
    {
        for(j=90; j<100; j++) setPixel(j,i,0);
        for(j=220; j<230; j++) setPixel(j,i,0);
    }
	
    for(i=50; i<110; i++)
    {
        for(j=239; j<310; j++) setPixel(j,i,12);
    }
	
	//unsigned init_timer=*get_timer();
	timer_value_to_restore = *get_timer(); //SpiroH
	
	*get_timer()=1000; //SpiroH
	
    score=0;
    lines=0;
    level=0;
    putChar(298, 55, 0,12);
    putChar(298, 75, 0,12);
    putChar(298, 95, 0,12);
	
    seed=*counter;
	
    nkpiece=random(7);
    nrpiece=random(4);
    newp();
    for(i=10; i<69; i++)
    {
        for(j=16; j<75; j++) setPixel(j,i,12);
    }
	
    for(i=0; i<5; i++)
    {
        for(j=0; j<5; j++)
        {
            if(getpiece(nkpiece,nrpiece,j,i)==1)
            {
                for(l=0; l<12; l++)
                {
                    for(k=0; k<12; k++)
                    {
                        setPixel(21+j*12+k-xloffset(nkpiece,nrpiece)*12,15+i*12+l-yuoffset(nkpiece,nrpiece)*12,gettexture(nkpiece,k,l));
                    }
                }
            }
        }
    }
	
	//return init_timer;
}
//-----------------
void newp()
{
	
    kpiece=nkpiece;
    rpiece=nrpiece;
    nkpiece=random(7);
    nrpiece=random(4);
    int i,j=0;
    for(i=0; i<60; i+=12)
    {
        posx[j]= 124+i;
        posy[j]= i-12*yloffset(kpiece, rpiece);
        j++;
    }
}
//-----------------
void move(int dir)
{
    int i;
    piece(1);
    switch(dir)
    {
    case 4:
        if(posx[xloffset(kpiece,rpiece)]>100&&validmove(4)==1)
        {
            for(i=0; i<5; i++)
            {
                posx[i]-=12;
            }
        }
        break;
    case 6:
        if(posx[xroffset(kpiece,rpiece)]<200&&validmove(6)==1)
        {
            for(i=0; i<5; i++)
            {
                posx[i]+=12;
            }
        }
        break;
    case 2:
        if(posy[yloffset(kpiece, rpiece)]<220&&validmove(2)==1)
        {
            for(i=0; i<5; i++)
            {
                posy[i]+=12;
            }
        }
        break;
    case 5:
        while(posy[yloffset(kpiece, rpiece)]<220&&validmove(2)==1)
        {
            for(i=0; i<5; i++)
            {
                posy[i]+=12;
            }
        }
        break;
    case 8:
        if(rpiece<3) rpiece++;
        else rpiece=0;
        if (validmove(8)==1&&posx[xroffset(kpiece,rpiece)]<212&&posx[xloffset(kpiece,rpiece)]>88) break;
        if(rpiece>0) rpiece--;
        else rpiece=3;
    }
    piece(0);
	
   if(is_classic) wait_no_key_pressed(); //SpiroH
}
//-----------------
void autom()
{
    int i,j,k,l,time=1200;
	
	if(*get_timer()==0) //SpiroH
    {
        if(posy[yloffset(kpiece, rpiece)]<220 && validmove(2)==1)
        {
            move(2);
            bonus--;
        }
        else
        {
            if(bonus>0) score+=bonus;
            level=lines/10%10;
            bonus=10;
            line();
            updscore();
            if(gameover()==1)
            {
                for(i=228; i>=0; i-=12)
                {
                    for(j=100; j<220; j+=12)
                    {
                        obj(j,i);
                        sleep(30);
                    }
                }
                wait_key_pressed();
                wait_no_key_pressed();
                clrscr();
                init();
            }
			
            newp();
			
            for(i=10; i<69; i++)
            {
                for(j=16; j<75; j++) setPixel(j,i,12);
            }
            for(i=0; i<5; i++)
            {
                for(j=0; j<5; j++)
                {
                    if(getpiece(nkpiece,nrpiece,j,i)==1)
                    {
                        for(l=0; l<12; l++)
                        {
                            for(k=0; k<12; k++)
                            {
                                setPixel(21+j*12+k-xloffset(nkpiece,nrpiece)*12,15+i*12+l-yuoffset(nkpiece,nrpiece)*12,gettexture(nkpiece,k,l));
                            }
                        }
                    }
                }
            }

            piece(0);
        }
		
        for(i=0; i<level; i++)
        {
            time-=time/10;
        }
		
		*get_timer()=time; //SpiroH
    }

}
//-----------------
int validmove(int dir)
{
    int i,j,k=1;
    for(i=0; i<5; i++)
    {
        for(j=0; j<5; j++)
        {
            if(getpiece(kpiece,rpiece,j,i)==1)
            {
                switch (dir)
                {
				 case 2: if(getPixel(posx[j],posy[i]+12)!=15&&getpiece(kpiece,rpiece,j,i+1)==0&&posy[i]>0) k=0; break;
                 case 4: if(getPixel(posx[j]-12,posy[i])!=15&&getpiece(kpiece,rpiece,j-1,i)==0&&posy[i]>0) k=0; break;
                 case 6: if(getPixel(posx[j]+12,posy[i])!=15&&getpiece(kpiece,rpiece,j+1,i)==0&&posy[i]>0) k=0; break;
                 case 8: if(getPixel(posx[j],posy[i])!=15&&posy[i]>0) k=0; break;
                }
            }
        }
    }
    return k;
}
//-----------------
int random(int max)
{
    long int hi = seed / 44488;
    long int lo = seed % 44488;

    seed = 48271 * lo - 3399 * hi;

    if (seed <= 0) seed += 2147483647;

    return (seed / (2147483646 / max))%max;
}
//-----------------
void line()
{
    int i,j,k,l;
    for(i=0; i<20; i++)
    {
        k=0;
        for(j=0; j<10; j++)
        {
            if (getPixel(100+j*12,i*12)!=15) k++;
        }
        if(k==10)
        {

            for (k=0; k<12; k++)
            {
                for(j=250-(SCREEN_HEIGHT-i*12); j>=0; j--)
                {
                    for(l=100; l<220; l++)
                    {
                        setPixel(l,j+1,getPixel(l,j));
                    }
                }
            }
            score+=50+50*level;
            lines++;
        }
    }
}
//-----------------
int gameover()
{
    int i;
    for(i=0; i<10; i++)
    {
        if (getPixel(100+i*12,0)!=15) return 1;
    }
    return 0;
}
//-----------------
void putChar(int x, int y, char ch, char bg) //made by ExtendeD
{
	
    int i, j, pixelOn;
    for(i = 0; i < 12; i++)
    {
        for(j = 0; j < 8; j++)
        {
            pixelOn = getnumber(ch,i) << j ;
            pixelOn = pixelOn & 0x80 ;
            if (pixelOn) setPixel(x + j, y + i, 0);
            else setPixel(x + j, y + i, bg);
        }
    }
}
//-----------------
void updscore()
{
    int i,score2=score,lines2=lines,ziffer[7];
    for(i=0; score2>0; i++)
    {
        ziffer[i]=score2%10;
        score2/=10;
        putChar(298-i*9, 55, ziffer[i],12);
    }
    for(i=0; lines2>0; i++)
    {
        ziffer[i]=lines2%10;
        lines2/=10;
        putChar(298-i*9, 75, ziffer[i],12);
    }
    putChar(298, 95, level,12);
}
